Codeforces Round #406 (Div. 1) B. Legacy 线段树建图跑最短路

B. Legacy

题目连接:

http://codeforces.com/contest/786/problem/B

Description

Rick and his co-workers have made a new radioactive formula and a lot of bad guys are after them. So Rick wants to give his legacy to Morty before bad guys catch them.

There are n planets in their universe numbered from 1 to n. Rick is in planet number s (the earth) and he doesn't know where Morty is. As we all know, Rick owns a portal gun. With this gun he can open one-way portal from a planet he is in to any other planet (including that planet). But there are limits on this gun because he's still using its free trial.

By default he can not open any portal by this gun. There are q plans in the website that sells these guns. Every time you purchase a plan you can only use it once but you can purchase it again if you want to use it more.

Plans on the website have three types:

With a plan of this type you can open a portal from planet v to planet u.
With a plan of this type you can open a portal from planet v to any planet with index in range [l, r].
With a plan of this type you can open a portal from any planet with index in range [l, r] to planet v.
Rick doesn't known where Morty is, but Unity is going to inform him and he wants to be prepared for when he finds and start his journey immediately. So for each planet (including earth itself) he wants to know the minimum amount of money he needs to get from earth to that planet.

Input

The first line of input contains three integers n, q and s (1 ≤ n, q ≤ 105, 1 ≤ s ≤ n) — number of planets, number of plans and index of earth respectively.

The next q lines contain the plans. Each line starts with a number t, type of that plan (1 ≤ t ≤ 3). If t = 1 then it is followed by three integers v, u and w where w is the cost of that plan (1 ≤ v, u ≤ n, 1 ≤ w ≤ 109). Otherwise it is followed by four integers v, l, r and w where w is the cost of that plan (1 ≤ v ≤ n, 1 ≤ l ≤ r ≤ n, 1 ≤ w ≤ 109).

Output

In the first and only line of output print n integers separated by spaces. i-th of them should be minimum money to get from earth to i-th planet, or  - 1 if it's impossible to get to that planet.

Sample Input

3 5 1
2 3 2 3 17
2 3 2 2 16
2 2 2 3 3
3 3 1 1 12
1 3 3 17

Sample Output

0 28 12

Hint

题意

三种操作:
1 a b c,在建立权值为c的a->b的单向边
2 a b c d,建立a->[b,c]权值为d的单向边
3 a b c d,建立[b,c]->a权值为d的单向边。

给你一个起点,问你起点到其他点的最短路长度。

题解:

如果暴力建边的话,显然会有n^2个边。

但是我们用线段树去建边就好了,我们依次让所有节点都指向自己区间的l端点和r端点就行了。

我相当于预先又建了nlogn个节点,这些虚拟节点代替区间。

然后跑dij就好了

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e6+7;
vector<pair<int,int> >v[maxn];
long long dist[maxn],ver[2][maxn];
int n,q,ss,tme;
set<pair<long long,int> >s;
int build(int y,int l,int r,int x){
    if(l==r)return ver[x][y]=l;
    ver[x][y]=++tme;
    int mid=(l+r)/2;
    int cl=build(y*2,l,mid,x);
    int cr=build(y*2+1,mid+1,r,x);
    if(x==0){
        v[ver[x][y]].push_back(make_pair(cl,0));
        v[ver[x][y]].push_back(make_pair(cr,0));
    }else{
        v[cl].push_back(make_pair(ver[x][y],0));
        v[cr].push_back(make_pair(ver[x][y],0));
    }
    return ver[x][y];
}
void update(int x,int l,int r,int ll,int rr,int xx,int w,int z){
    if(l>rr||r<ll)return;
    if(l>=ll&&r<=rr){
        if(z==0)v[xx].push_back(make_pair(ver[z][x],w));
        else v[ver[z][x]].push_back(make_pair(xx,w));
        return;
    }
    int mid=(l+r)/2;
    update(x*2,l,mid,ll,rr,xx,w,z);
    update(x*2+1,mid+1,r,ll,rr,xx,w,z);
}
int main(){
    cin>>n>>q>>ss;
    memset(dist,-1,sizeof(dist));
    tme=n;
    build(1,1,n,0);
    build(1,1,n,1);
    for(int i=0;i<q;i++){
        int t,a,b,c,d;
        cin>>t>>a>>b>>c;
        if(t==1){
            v[a].push_back(make_pair(b,c));
        }else{
            cin>>d;
            update(1,1,n,b,c,a,d,t-2);
        }
    }
    dist[ss]=0;
    priority_queue<pair<long long,int> >Q;
    Q.push(make_pair(0,ss));
    while(!Q.empty()){
        int now = Q.top().second;
        Q.pop();
        for(int i=0;i<v[now].size();i++){
            int ve=v[now][i].first;
            int co=v[now][i].second;
            if(dist[ve]==-1||dist[now]+co<dist[ve]){
                dist[ve]=dist[now]+co;
                Q.push(make_pair(-dist[ve],ve));
            }
        }
    }
    for(int i=1;i<=n;i++)
        cout<<dist[i]<<" ";
    cout<<endl;
}
posted @ 2017-03-31 15:06  qscqesze  阅读(912)  评论(5编辑  收藏  举报